// 004 u_c_cassini_spy
// 16 feb 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_cassini_spy;
  interface
    uses u_c_basic_object
        , u_c_byte_buffer
        , u_c_server_socket_4
        , u_cassini_spy_display_event
        ;

    type c_cassini_spy= Class;
         t_po_tcp_cassini_spy_event= Procedure(p_c_cassini_spy: c_cassini_spy) of object;

         c_cassini_spy= class(c_basic_object)
                         m_c_server_socket: c_server_socket;
                         m_spy_cassini_port: Integer;

                         m_trace_cassini_spy: Boolean;
                         m_site_path: String;

                         m_on_accept_tcp_cassini_spy_socket: t_po_tcp_cassini_spy_event;
                         m_on_spy_display_cassini_spy_event: t_po_cassini_spy_display_event;

                         Constructor create_cassini_spy(p_name, p_site_path: String;
                             p_spy_cassini_port: Integer);

                         procedure start_cassini_spy(p_ie_port: Integer);
                         procedure handle_accept(p_c_server_socket: c_server_socket;
                             p_c_server_client_socket: c_server_client_socket);
                         procedure close_cassini_spy;

                         Destructor Destroy; Override;
                       end; // c_cassini_spy

  implementation
    uses Classes, SysUtils, u_c_display, u_types_constants
        , u_c_cassini_spy_server_client_socket
        ;

    // -- c_cassini_spy

    Constructor c_cassini_spy.create_cassini_spy(p_name, p_site_path: String;
        p_spy_cassini_port: Integer);
      begin
        Inherited create_basic_object(p_name);
        m_site_path:= p_site_path;
        m_spy_cassini_port:= p_spy_cassini_port;

        // -- specify which c_server_client_sockt Class should be created
        m_c_server_socket:= c_server_socket.create_server_socket('server',
            c_cassini_spy_server_client_socket);
        m_c_server_socket.m_on_after_accept:= handle_accept;
      end; // create_cassini_spy

    procedure c_cassini_spy.start_cassini_spy(p_ie_port: Integer);
      begin
        with m_c_server_socket do
        begin
          m_trace_socket:= m_trace_cassini_spy;

          wsa_startup;
          create_win_socket;
          wsa_select;
          do_bind_win_socket(p_ie_port);
          do_listen_to_client(k_default_listen_queue_size)
        end; // with m_c_server_socket
      end; // start_cassini_spy

    procedure c_cassini_spy.handle_accept(p_c_server_socket: c_server_socket;
        p_c_server_client_socket: c_server_client_socket);
      begin
        // -- use the same Memo2 display
        with (p_c_server_client_socket as c_cassini_spy_server_client_socket) do
        begin
          m_cassini_port:= m_spy_cassini_port;
          m_on_display_cassini_spy_event:= m_on_spy_display_cassini_spy_event;
        end;

        // -- feed back to the caller
        if Assigned(m_on_accept_tcp_cassini_spy_socket)
          then m_on_accept_tcp_cassini_spy_socket(Self);
      end; // handle_accept

    procedure c_cassini_spy.close_cassini_spy;
      begin
        m_c_server_socket.do_close_win_socket;
      end; // close_cassini_spy

    Destructor c_cassini_spy.Destroy;
      begin
        close_cassini_spy;
        m_c_server_socket.Free;

        Inherited;
      end; // Destroy

    begin // u_c_cassini_spy
    end. // u_c_cassini_spy

spy

