// 002 u_c_cassini_spy_client_socket
// 16 feb 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

// -- the tee client

(*$r+*)

unit u_c_cassini_spy_client_socket;
  interface
    uses u_c_basic_object
       , u_c_client_socket_4
       , u_c_byte_buffer
       ;

    type c_cassini_spy_client_socket= Class; // Forward
         t_po_cassini_spy_client_socket_event= procedure(p_c_cassini_spy_client_socket: c_cassini_spy_client_socket) of object;

         c_cassini_spy_client_socket= class(c_client_socket)
                                m_c_cassini_spy_text_to_send_ref: c_byte_buffer;
                                m_on_cassini_spy_received_data: t_po_cassini_spy_client_socket_event;

                                Constructor create_cassini_spy_client_socket(p_name: String);

                                procedure trace_cassini_spy_client(p_text: String);

                                procedure connect_to_cassini(p_server: String; p_port: Integer);
                                procedure handle_connected(p_c_client_socket: c_client_socket);
                                procedure handle_received_data(p_c_client_socket: c_client_socket);
                                procedure handle_remote_server_client_socket_closed(p_c_client_socket: c_client_socket);

                                Destructor Destroy; Override;
                              end; // c_cassini_spy_client_socket

  implementation
    uses SysUtils, u_c_display;

    // -- c_cassini_spy_client_socket

    Constructor c_cassini_spy_client_socket.create_cassini_spy_client_socket(p_name: String);
      begin
        Inherited create_client_socket(p_name);

        m_trace_socket:= True;

        m_on_after_socket_connected:= handle_connected;
        m_on_after_socket_received_data:= handle_received_data;
        m_on_after_remote_server_client_socket_closed:= handle_remote_server_client_socket_closed;
      end; // create_cassini_spy_client_socket

    procedure c_cassini_spy_client_socket.trace_cassini_spy_client(p_text: String);
      begin
        display(p_text);
      end; // trace_cassini_spy_client

    procedure c_cassini_spy_client_socket.connect_to_cassini(p_server: String; p_port: Integer);
      begin
        trace_cassini_spy_client('> connect_to_cassini');

        wsa_startup;
        // display_wsa_data;
        create_win_socket;
        wsa_select;
        do_connect_win_socket(p_server, p_port);

        trace_cassini_spy_client('< connect_to_cassini');
      end; // connect_to_cassini

    procedure c_cassini_spy_client_socket.handle_connected(p_c_client_socket: c_client_socket);
      begin
        display('> cassini_connected');
        // -- now forward the text to cassini
        with m_c_cassini_spy_text_to_send_ref do
          if m_write_index> 0
            then f_do_send_buffer(@ m_oa_byte_buffer[0], m_write_index);

        display('< cassini_connected');
      end; // handle_connected

    procedure c_cassini_spy_client_socket.handle_received_data(p_c_client_socket: c_client_socket);
        // -- fd_read notification was received
      var l_received_text: String;
      begin
        display('> tee_received');
        // -- notify IE
        if Assigned(m_on_cassini_spy_received_data)
          then m_on_cassini_spy_received_data(Self);
        display('< tee_received');
      end; // handle_received_data

    procedure c_cassini_spy_client_socket.handle_remote_server_client_socket_closed(p_c_client_socket: c_client_socket);
      begin
        // -- change colors
      end; // handle_remote_server_client_socket_closed

//        g_c_client_socket.do_close_win_socket;

    Destructor c_cassini_spy_client_socket.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_cassini_spy_client_socket
    end. // u_c_cassini_spy_client_socket


