// 005 u_c_cassini_spy_server_client_socket
// 16 feb 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

// -- will receive IE requests on 8080, and forward them to the web on 80 (-> cassini)

(*$r+*)

unit u_c_cassini_spy_server_client_socket;
  interface
    uses u_c_basic_object
        , u_c_server_socket_4
        , u_c_cassini_spy_client_socket
        , u_cassini_spy_display_event
        ;

    type c_cassini_spy_server_client_socket= class(c_server_client_socket)
                                        m_on_display_cassini_spy_event: t_po_cassini_spy_display_event;
                                        m_cassini_port: Integer;

                                        // -- send to the web (-> to cassini)
                                        m_c_cassini_spy_client_socket: c_cassini_spy_client_socket;

                                        Constructor create_server_client_socket(p_name: String;
                                            p_c_server_socket_ref: c_server_socket); Override;

                                        procedure handle_can_write_data; Override;
                                        procedure handle_received_data; Override;
                                        procedure handle_remote_client_closed; Override;

                                        procedure handle_received_data_from_cassini(p_c_cassini_spy_client_socket: c_cassini_spy_client_socket);

                                        Destructor Destroy; Override;
                                      end; // c_cassini_spy_server_client_socket

  implementation
    uses Windows, Classes, SysUtils
        , u_c_display, u_types_constants, u_characters, u_strings
        , u_file
        , u_c_byte_buffer
        ;

    // -- c_cassini_spy_server_client_socket

    Constructor c_cassini_spy_server_client_socket.create_server_client_socket(p_name: String;
        p_c_server_socket_ref: c_server_socket);
      begin
        Inherited create_server_client_socket(p_name, p_c_server_socket_ref);

        m_c_cassini_spy_client_socket:= c_cassini_spy_client_socket.create_cassini_spy_client_socket('tee_client');
        m_c_cassini_spy_client_socket.m_on_cassini_spy_received_data:= handle_received_data_from_cassini;
      end; // create_server_client_socke

    procedure c_cassini_spy_server_client_socket.handle_can_write_data;
      begin
        trace_socket('> c_cassini_spy_server_client.write');
        trace_socket('< c_cassini_spy_server_client.write');
      end; // handle_can_write_data

    procedure c_cassini_spy_server_client_socket.handle_received_data;
        // -- received some data from the browser
      var l_end_of_header_position: Integer;
          l_read_index: Integer;
      begin
        trace_socket('> c_cassini_spy_server_client.read, port '+ IntToStr(m_cassini_port));

        // -- fetch the bytes
        receive_buffered_data;

        with m_c_reception_buffer do
        begin
          with m_c_reception_buffer do
            display('> analyze_header AAA '+ Format('%5d %5d ', [m_read_index, m_write_index]));

          if Assigned(m_on_display_cassini_spy_event)
            then
              with m_c_reception_buffer do
                m_on_display_cassini_spy_event(1, f_display_buffer(m_read_index, m_write_index));

          // -- set the text to send to Cassini
          m_c_cassini_spy_client_socket.m_c_cassini_spy_text_to_send_ref:= m_c_reception_buffer;

          m_c_cassini_spy_client_socket.connect_to_cassini('127.0.0.1', m_cassini_port);

          display('< analyze_header');
        end; // with p_c_byte_buffer

        trace_socket('< c_cassini_spy_server_client.read');
      end; // handle_received_data

    procedure c_cassini_spy_server_client_socket.handle_received_data_from_cassini(p_c_cassini_spy_client_socket: c_cassini_spy_client_socket);
        // -- now CASSINI did send the answer

      procedure send_back(p_c_reception_buffer: c_byte_buffer);
        begin
          with p_c_reception_buffer do
          begin
             trace_socket('send_to_ie '+ IntToStr(m_write_index));
             // -- the server_client_socket sends back
             f_do_send_buffer(@ m_oa_byte_buffer[m_read_index], m_write_index);

             // -- move forward
             m_read_index:= m_write_index;
           end; // with p_c_byte_buffer
        end; // send_back

      begin // handle_received_data_from_cassini
        with m_c_reception_buffer do
          trace_socket('> c_cassini_spy_server_client.received BBB '+ Format('%5d %5d ', [m_read_index, m_write_index]));

        // -- received an answer from Cassini
        // -- forward to IE
        with p_c_cassini_spy_client_socket, m_c_reception_buffer do
          if m_write_index> 0
            then begin
                if Assigned(m_on_display_cassini_spy_event)
                  then m_on_display_cassini_spy_event(2, f_display_buffer(m_read_index, m_write_index));

                send_back(m_c_reception_buffer);
              end;

        trace_socket('< c_cassini_spy_server_client.received');
      end; // handle_received_data_from_cassini

    procedure c_cassini_spy_server_client_socket.handle_remote_client_closed;
      begin
      end; // handle_remote_client_closed

    Destructor c_cassini_spy_server_client_socket.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_cassini_spy_server_client_socket
    end. // u_c_cassini_spy_server_client_socket
