// 003 u_cassini_spy
// 09 jan 97

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_cassini_spy;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
        , StdCtrls
        , ExtCtrls, ComCtrls
        , u_c_base_socket_4

        , u_c_server_socket_4
        , u_c_cassini_spy
        , u_cassini_spy_display_event
        ;

    type TForm1= class(TForm)
                  Panel1: TPanel;
    ie_port_: TEdit;
                  clear_: TButton;
                  exit_: TButton;
    ie_: TLabel;
    go_: TPanel;
    close_socket_: TPanel;
    PageControl1: TPageControl;
    protocol_: TTabSheet;
    content_: TTabSheet;
    Memo1: TMemo;
    content_memo_: TMemo;
    cassini_port_: TEdit;
    cassini: TLabel;
    raw_content_: TTabSheet;
    raw_content_memo_: TMemo;
    save_content_: TButton;
                   procedure FormCreate(Sender: TObject);
                   procedure clear_Click(Sender: TObject);
                   procedure exit_Click(Sender: TObject);
    procedure go_Click(Sender: TObject);
    procedure close_socket_Click(Sender: TObject);
    procedure save_content_Click(Sender: TObject);
                   private
                     procedure handle_tcp_cassini_spy_accept(p_c_cassini_spy: c_cassini_spy);
                     procedure handle_cassini_spy_display(p_code: Integer; p_text: String);
                   public
                 end;

    var Form1: TForm1;

  implementation
    uses
        u_types_constants, u_characters
        , u_c_log, u_c_display, u_display_hex_2
        , u_file, u_exe
      ;

    {$R *.DFM}

    const k_site_path= '..\xxx_tcp_cassini_spy_tracer\_site_tee\';
    var g_c_cassini_spy: c_cassini_spy= Nil;

    procedure set_panel_color(p_c_panel: tPanel; p_color: Integer);
      begin
        p_c_panel.Color:= p_color;
        Application.ProcessMessages;
      end; // set_panel_color

    // -- user actions

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_panel_color(go_, clLime);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
        content_memo_.Lines.Clear;
        raw_content_memo_.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        g_c_cassini_spy.Free;
        g_c_display.Free;
        Close;
      end; // exit_Click

    var g_request_count: Integer= 0;

    procedure TForm1.handle_cassini_spy_display(p_code: Integer; p_text: String);
        // -- 1 from IE, 2 from CASSINI
      var l_spaces: String;

      procedure do_add(p_text: String);
        begin
          content_memo_.Lines.Add(l_spaces+ p_text);
          raw_content_memo_.Lines.Add(p_text);
        end; // do_add

      var l_index: Integer;
          l_the_line: String;

      begin // handle_cassini_spy_display
        case p_code of
          1 : begin
                l_spaces:= '';
                do_add('');
                do_add(IntToStr(g_request_count)+ ' ====================================== '+ IntToStr(Length(p_text)));
                Inc(g_request_count);

                l_spaces:= '    -> | ';
              end;
          2 : begin
                l_spaces:= '';
                do_add('');
                do_add('--------------------------------------'+ IntToStr(Length(p_text)) );

                l_spaces:= ' <-    | ';
              end;
          else l_spaces:= '??';
        end; // case

        l_the_line:= '';
        l_index:= 1;
        while l_index<= Length(p_text) do
          if p_text[l_index]= k_return
            then begin
                do_add(l_the_line);
                l_the_line:= '';
                Inc(l_index, 2);
              end
            else begin
                l_the_line:= l_the_line+ p_text[l_index];
                Inc(l_index);
              end;

        // -- flush      
        if l_the_line<> ''
          then do_add(l_the_line);
      end; // handle_cassini_spy_display

    procedure TForm1.handle_tcp_cassini_spy_accept(p_c_cassini_spy: c_cassini_spy);
      begin
        display('accept ');
      end; // handle_tcp_cassini_spy_accept

    procedure TForm1.go_Click(Sender: TObject);
      begin
        // -- free any previous spy
        g_c_cassini_spy.Free;

        g_c_cassini_spy:= c_cassini_spy.create_cassini_spy('cassini_spy',
            k_site_path, StrToInt(cassini_port_.Text));

        with g_c_cassini_spy do
        begin
          m_trace_cassini_spy:= True;
          start_cassini_spy(StrToInt(ie_port_.Text));
          m_on_accept_tcp_cassini_spy_socket:= handle_tcp_cassini_spy_accept;
          m_on_spy_display_cassini_spy_event:= handle_cassini_spy_display;
        end;

        set_panel_color(go_, clRed);
        set_panel_color(close_socket_, clLime);
      end; // go_pane_lClick

    procedure TForm1.close_socket_Click(Sender: TObject);
      begin
        g_c_cassini_spy.m_c_server_socket.do_close_win_socket;
        set_panel_color(close_socket_, clRed);
        set_panel_color(go_, clLime);
      end; // close_socket_Click

    procedure TForm1.save_content_Click(Sender: TObject);
      begin
        content_memo_.Lines.SaveToFile(f_exe_path+ 'log\content.txt');
        raw_content_memo_.Lines.SaveToFile(f_exe_path+ 'log\raw_content.txt');
      end;

end.
